diff -bwcr wais-8-b5/ir/ircfiles.c w8b5bio/ir/ircfiles.c
*** wais-8-b5/ir/ircfiles.c	Wed May  6 19:27:43 1992
--- w8b5bio/ir/ircfiles.c	Sun Nov  8 19:09:51 1992
***************
*** 196,203 ****
     I'm open to better code.  - Jonny G
  */
  
- static char *months[] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun",
- 			"Jul", "Aug", "Sep", "Oct", "Nov", "Dec", NULL};
  
  long my_getdate(line)
  char *line;
--- 1402,1407 ----
***************
*** 888,895 ****
--- 2092,2118 ----
   * just like 'mail'.
   *
   * wollman@uvm.edu, Sun Sep  8 20:12:21 EDT 1991
+  *
+  * dgg added "Path:" fix for netnews/NNTP fetches (!NOT MAIL, NO "From ")
+  * gilbertd@sunflower.bio.indiana.edu
   */
  boolean rn_separator_function(line)
+ char *line;
+ {
+   if(!strncmp(line,"From ",5) ||
+     !strncmp(line,"Path: ",6) ||
+     !strncmp(line,"Article ",7) ||
+     !strncmp(line,"Article: ",9))
+     return true;
+   return false;
+ }
+ 
+ /*
+  * Customization for files saved NNTP netnews fetches (!NOT MAIL FORMAT, NO "From ".
+  *
+  * gilbertd@sunflower.bio.indiana.edu
+  */
+ boolean netnews_separator_function(line)
  char *line;
  {
    if(!strncmp(line,"From ",5) ||
diff -bwcr wais-8-b5/ir/ircfiles.h w8b5bio/ir/ircfiles.h
*** wais-8-b5/ir/ircfiles.h	Wed May  6 19:29:27 1992
--- w8b5bio/ir/ircfiles.h	Sun Nov  8 19:10:49 1992
***************
*** 32,37 ****
--- 32,86 ----
  	{
  #endif /* def __cplusplus */
  
+ #ifdef BIO
+ /* genbank flat files -- dgg*/
+ boolean genbank_separator_function _AP((char *line));
+ void genbank_header_function _AP((char *line));
+ void genbank_finish_header_function _AP((char *header));
+ long genbank_date_function _AP((char *line));
+ 
+ /* embl flat files -- dgg*/
+ boolean embl_separator_function _AP((char *line));
+ void embl_header_function _AP((char *line));
+ void embl_finish_header_function _AP((char *header));
+ long embl_date_function _AP((char *line));
+ 
+ /* pir flat files -- dgg*/
+ boolean pir_separator_function _AP((char *line));
+ void pir_header_function _AP((char *line));
+ void pir_finish_header_function _AP((char *header));
+ long pir_date_function _AP((char *line));
+ 
+ /* prosite protein doc & dat files - dgg */
+ boolean prositedoc_separator_function _AP((char *line));
+ void prositedoc_header_function _AP((char *line));
+ void prositedoc_finish_header_function _AP((char *header));
+ 
+ boolean prositedat_separator_function _AP((char *line));
+ void prositedat_header_function _AP((char *line));
+ void prositedat_finish_header_function _AP((char *header));
+ 
+ /* Bionet.journals table of contents format */
+ boolean biojournal_separator_function _AP((char *line));
+ void biojournal_header_function _AP((char *line));
+ void biojournal_finish_header_function _AP((char *header));
+ 
+ /* drosophila redbook -dgg */
+ boolean redbook_separator_function _AP((char *line));
+ void redbook_header_function _AP((char *line));
+ void redbook_finish_header_function _AP((char *header));
+ 
+ /* drosophila flybase -dgg */
+ boolean flybase_separator_function _AP((char *line));
+ void flybase_header_function _AP((char *line));
+ void flybase_finish_header_function _AP((char *header));
+ 
+ boolean din_separator_function _AP((char *line));
+ void din_finish_header_function _AP((char *header));
+ void din_header_function _AP((char *line));
+ 
+ #endif /* BIO */
+ 
  /* groliers encyclopedia */
  boolean groliers_separator_function _AP((char *line));
  void groliers_header_function _AP((char *line));
Only in w8b5bio/ir: irext.h.O
diff -bwcr wais-8-b5/ir/irfiles.c w8b5bio/ir/irfiles.c
*** wais-8-b5/ir/irfiles.c	Thu Apr 30 17:11:18 1992
--- w8b5bio/ir/irfiles.c	Sat Oct 31 19:05:43 1992
***************
*** 138,143 ****
--- 138,146 ----
  
  #define FILENAME_TABLE_HEADER_SIZE 4
  #define HEADLINE_TABLE_HEADER_SIZE 4
+ #ifdef BIO
+ #define DELIMITERS_SIZE 4
+ #endif
  
  #define FILE_WRITE_DATE_SIZE 4
  #define NUMBER_OF_OCCURANCES_SIZE 4
***************
*** 315,320 ****
--- 318,335 ----
        disposeDatabase(db);
        return(NULL);
      }
+ 
+ #ifdef BIO
+     db->delimiters_stream = 
+       s_fopen(delimiters_filename(file, db),open_mode);
+     if (db->delimiters_stream == NULL){
+       waislog(WLOG_HIGH, WLOG_ERROR,
+ 	      "can't open the delimiters file %s, using defaults", file); 
+       /* disposeDatabase(db); */
+       /* return(NULL); */
+     }
+ #endif
+ 
      db->document_table_stream = 
        s_fopen(document_table_filename(file, db),open_mode);
      if (db->document_table_stream == NULL){ 
***************
*** 458,463 ****
--- 473,483 ----
    db->headline_table_stream =
      initialize_file(HEADLINE_TABLE_HEADER_SIZE,
  		    headline_table_filename(file, db), TRUE);
+ #ifdef BIO
+   db->delimiters_stream =
+     initialize_file(DELIMITERS_SIZE,
+ 		    delimiters_filename(file, db), TRUE);
+ #endif
  }
  
  /* ========================= */
***************
*** 571,588 ****
  }
  #endif
  
  static long find_pointer_in_block _AP((char* word,unsigned char* block,
  				       long block_length,
! 				       long *position
  				       ));
  
  /* Courtesy of Simon Spero <ses@techunix.technion.ac.il> */
  
! static long find_pointer_in_block(word,block,block_length, position)
  char *word;
  unsigned char *block;
  long block_length; /* in entries */ 
  long *position;
  /* returns 0 if an error or if the word is below the lowest block,
     (this confusion between error and NULL is bad, but found late in the 
     design process)
--- 591,645 ----
  }
  #endif
  
+ 
+ #ifdef PARTIALWORD
+ 
+ typedef struct {
+ 	long  blocknum, wordcount;
+ 	} saveparttype;
+ 	
+ static long gMaxpart = 0;
+ static long gNpart = 0;
+ static long gAtpart = 0;
+ static saveparttype *gSavepart = NULL;
+ 
+ void clearPartMatch()
+ {
+   if (gSavepart!=NULL) free(gSavepart);
+   gSavepart= NULL;
+   gMaxpart= 0;
+   gNpart= 0;
+   gAtpart= 0;
+ }
+ 
+ void savePartMatch( blocknum, wordcount)
+ long  blocknum, wordcount;
+ {
+    if (gNpart>=gMaxpart) {
+      gMaxpart= gNpart + 100;
+      if (gSavepart==NULL) (void*) gSavepart= malloc(gMaxpart*sizeof(saveparttype));
+      else (void*) gSavepart= realloc(gSavepart, gMaxpart*sizeof(saveparttype));
+      }
+    gSavepart[gNpart].blocknum= blocknum;
+    gSavepart[gNpart].wordcount= wordcount;
+    gNpart++;
+ }
+ #endif
+ 
  static long find_pointer_in_block _AP((char* word,unsigned char* block,
  				       long block_length,
! 				       long *position,
! 				       boolean findpart
  				       ));
  
  /* Courtesy of Simon Spero <ses@techunix.technion.ac.il> */
  
! static long find_pointer_in_block(word,block,block_length, position, findpart)
  char *word;
  unsigned char *block;
  long block_length; /* in entries */ 
  long *position;
+ boolean findpart;  /* dgg, partial word match */
  /* returns 0 if an error or if the word is below the lowest block,
     (this confusion between error and NULL is bad, but found late in the 
     design process)
***************
*** 597,602 ****
--- 654,663 ----
       returns 0 if not found. */
    /* this could be binary search XXX */
    long i,high,low,tmp;
+ #ifdef PARTIALWORD
+   long  wordlen= strlen(word);
+ #endif
+ 
    low = 0;
    high = block_length;
    i = (low+high)/2;
***************
*** 616,622 ****
--- 677,714 ----
  	return(- dictionary_block_position(i-1,block));
        }
      } else {
+ #ifdef PARTIALWORD
+      if (findpart) {
+        compare = strncmp(dictionary_word, word, wordlen);
+        if ((0 == compare) /*&& (wordlen < strlen(dictionary_word))*/ ) {
+         int  ati = i;
+ 	/* save partword matches for later... */
+ 	savePartMatch( dictionary_block_position(i, block),
+ 		       dictionary_block_word_occurances(i,block));
+ 	while (i>low && 0 == compare) {
+ 	  --i;
+ 	  dictionary_word = dictionary_block_word(i, block);
+           compare = strncmp(dictionary_word, word, wordlen);
+   	  if (0 == compare) savePartMatch( dictionary_block_position(i, block),
+ 		      			   dictionary_block_word_occurances(i,block));
+ 	  }
+ 	i= ati;
+ 	while (i<high && 0 == compare) {
+ 	  ++i;
+ 	  dictionary_word = dictionary_block_word(i, block);
+           compare = strncmp(dictionary_word, word, wordlen);
+   	  if (0 == compare) savePartMatch( dictionary_block_position(i, block),
+ 		      			   dictionary_block_word_occurances(i,block));
+ 	  }
+ 	*position = ati;
+ 	return(-dictionary_block_position(ati, block));
+ 	}
+        }
+      else compare = strcmp(dictionary_word, word);
+ #else
       compare = strcmp(dictionary_word, word);
+ #endif	    
+ 
        if(0 == compare) {
  	dictionary_last_word_occurances = 
  	  dictionary_block_word_occurances(i,block);
***************
*** 695,701 ****
--- 787,827 ----
    return(block);
  }
  
+ 
+ #ifdef PARTIALWORD
+ 
  long 
+ look_up_partialword_in_dictionary(word, number_of_occurances, db)
+ char *word;
+ long *number_of_occurances;
+ database* db;
+ {
+   long answer;
+   boolean findpart = false;
+ 
+   if (word != NULL) {
+     clearPartMatch();
+     answer= look_up_word_in_dictionary( word, number_of_occurances, db);
+     if (answer > 0) return (answer); /* got a match */
+     }
+     
+   if (gAtpart >= gNpart) {
+     clearPartMatch();
+     return(-1);
+     }
+   else {
+     answer= gSavepart[gAtpart].blocknum;
+     if (NULL != number_of_occurances) {
+       if (answer > 0) *number_of_occurances = gSavepart[gAtpart].wordcount;
+       else *number_of_occurances = 0;
+       }
+     gAtpart++;
+     return( answer);
+     }
+ }
+ #endif
+ 
+ long 
  look_up_word_in_dictionary(word, number_of_occurances, db)
  char *word;
  long *number_of_occurances;
***************
*** 713,719 ****
--- 839,856 ----
    long answer;
    FILE *stream = db->dictionary_stream;
    long dictionary_block_pos;
+   boolean findpart = false; /* dgg, PARTIALWORD flag */
  
+ #ifdef PARTIALWORD
+   {
+     int l = strlen(word) - 1;
+     if (l > 0 && word[l] == PARTWORD_WILDCARD) {
+       findpart= true;
+       word[l]= '\0';
+       }
+   }
+ #endif
+ 
    if(NULL == dictionary_header_block)
     {
       s_fseek(stream, 0L, SEEK_SET);
***************
*** 733,739 ****
      find_pointer_in_block(word,
  			   dictionary_header_block,
  			   number_of_dictionary_blocks,
! 			   &position);
    if(0 == dictionary_block_pos)
     { /* waislog(WLOG_HIGH, WLOG_ERROR, "Could not find pointer for word '%s' (location %ld) in block in db %s!",
  	     word, word, db->database_file); */
--- 870,876 ----
      find_pointer_in_block(word,
  			   dictionary_header_block,
  			   number_of_dictionary_blocks,
! 			   &position, false);
    if(0 == dictionary_block_pos)
     { /* waislog(WLOG_HIGH, WLOG_ERROR, "Could not find pointer for word '%s' (location %ld) in block in db %s!",
  	     word, word, db->database_file); */
***************
*** 751,757 ****
       return(0);
     }
    answer = find_pointer_in_block(word, dictionary_block, 
! 				 DICTIONARY_BLOCK_SIZE, &position);
    if((NULL != number_of_occurances)) {
      if (answer > 0)
      *number_of_occurances = 
--- 888,894 ----
       return(0);
     }
    answer = find_pointer_in_block(word, dictionary_block, 
! 				 DICTIONARY_BLOCK_SIZE, &position, findpart);
    if((NULL != number_of_occurances)) {
      if (answer > 0)
      *number_of_occurances = 
***************
*** 1450,1456 ****
--- 1587,1636 ----
    return(free_position);
  }
  
+ #ifdef BIO
+ /*========================*
+  *=== delimiters - dgg ===*
+  *========================*/
  
+ char *read_delimiters(db)
+ database* db;
+   /* returns the word delimiters for a database.  Beware that 
+    * the next call to this function will overwrite the the headline_array
+    */
+ {
+   static char delimiters[MAX_HEADLINE_LEN+1]; 
+   FILE *stream = db->delimiters_stream;
+   delimiters[0] = '\0';	/* init to the empty string */
+ 	
+   if(false == read_string_from_file(db->delimiters_stream, 
+ 				    delimiters, MAX_HEADLINE_LEN)){ 
+    waislog(WLOG_HIGH, WLOG_ERROR, 
+ 	    "delimiters are corrupt in db %s",  db->database_file);
+   }
+   /* need to weed out .dlm files that have no symbols... */
+   if (delimiters[0] == '\0') return(NULL);
+   return(delimiters);
+ }
+ 
+ /* writes the string to the file followed by a NULL.
+  * The returned number is the position in the file to start reading.
+  */
+ long write_delimiters(delimiters,db)
+ char* delimiters;
+ database* db;
+ {
+   /* writes the headline followed by a newline.
+      Returns the postion of the headline.
+      */
+   long free_position;
+   s_fseek(db->delimiters_stream, 0L, SEEK_SET); /* _SET, only one set of delims / file ? */
+   free_position = ftell(db->delimiters_stream);
+   fprintf(db->delimiters_stream, "%s", delimiters);
+   fputc(0, db->delimiters_stream);
+   return(free_position);
+ }
+ #endif
+ 
  /* =================== */
  /* === Source file === */
  /* =================== */
***************
*** 1666,1671 ****
--- 1844,1861 ----
  	s_strncat(destination,headline_table_ext,MAX_FILE_NAME_LEN,MAX_FILE_NAME_LEN);
  	return(destination);
  }
+ 
+ #ifdef BIO
+ char* delimiters_filename(destination,db)
+ char* destination;
+ database* db;
+ {
+ 	strncpy(destination, db->database_file,MAX_FILE_NAME_LEN);
+ 	s_strncat(destination,delimiters_ext,MAX_FILE_NAME_LEN,MAX_FILE_NAME_LEN);
+ 	return(destination);
+ }
+ #endif
+ 
  char* index_filename(destination,db)
  char* destination;
  database* db;
diff -bwcr wais-8-b5/ir/irfiles.h w8b5bio/ir/irfiles.h
*** wais-8-b5/ir/irfiles.h	Thu Apr 16 22:04:45 1992
--- w8b5bio/ir/irfiles.h	Sun Nov  8 19:12:09 1992
***************
*** 35,40 ****
--- 35,43 ----
  #define index_ext			".inv"
  #define source_ext 			".src"
  #define catalog_ext 			".cat"
+ #ifdef BIO
+ #define delimiters_ext	".dlm"	    /* dgg */
+ #endif
  
  /* these dictionary definitions are used in irhash,irverify, and irfiles */
  #define DICTIONARY_HEADER_SIZE 4
***************
*** 47,56 ****
--- 50,75 ----
  #define DICTIONARY_TOTAL_SIZE_WORD "{}" /* the word that holds the total number of words in the whole dictionary */
  
  #define INDEX_HEADER_SIZE 4
+ #ifdef BIO
+ 
+ /* !! Bug in W8B5 -- Increasing this INDEX_BLOCK_SIZE_SIZE above 2 now fails !! */
+ /* it worked in W8B3 ... both 3 and 4 fail now */
+ #define INDEX_BLOCK_SIZE_SIZE 2  /* was 2, genbank wants 3, dgg */
+ 
+ #else
  #define INDEX_BLOCK_SIZE_SIZE 2
+ #endif
+ 
  #define NEXT_INDEX_BLOCK_SIZE 4
  #define INDEX_BLOCK_FLAG_SIZE 1
+ 
+ /* dgg -- this is a bug 
  #define INDEX_BLOCK_HEADER_SIZE 7
+ This == 7 only if the component SIZEs don't change
+ */
+ #define INDEX_BLOCK_HEADER_SIZE (INDEX_BLOCK_SIZE_SIZE+NEXT_INDEX_BLOCK_SIZE+INDEX_BLOCK_FLAG_SIZE)
+ 
+ 
  #define NUMBER_OF_OCCURANCES_SIZE 4
  #define INDEX_BLOCK_NOT_FULL_FLAG 101
  #define INDEX_BLOCK_FULL_FLAG 69
***************
*** 63,68 ****
--- 82,105 ----
  #define INDEX_ELEMENT_SIZE 8
  #define WORD_ID_SIZE 4 /* for posting arrays */
  
+ #ifdef BOOLEANS			/* dgg */
+ #define BOOLEAN_AND	"and"	/* may prefer "&", but need symbol fix */
+ #define BOOLEAN_NOT "not"	/* may prefer "!", but need symbol fix */
+ #define BOOLEAN_NOT_FLAG -91	/* stick in weight param as flag for search_word */
+ #endif
+ 
+ #ifdef PARTIALWORD		/* dgg */
+ #define PARTWORD_WILDCARD  '*'		
+ #endif
+ 
+ #ifdef LITERAL			/* dgg */
+ #define LITERAL_KEY1	'"'	
+ #define LITERAL_KEY2	0x27    /* single quote ' dgg */
+ #define LITERAL_FLAG	-92	/* stick in weight param as flag for search_word */
+ #define MAX_PHRASE_LENGTH  200
+ #endif
+ 
+ 
  typedef struct database {
  	char*	database_file;
  	FILE*	dictionary_stream;
***************
*** 70,75 ****
--- 107,115 ----
  	FILE*	headline_table_stream;
  	FILE*	document_table_stream;
  	FILE*	index_stream;
+ #ifdef BIO
+ 	FILE*	delimiters_stream;
+ #endif
    long	doc_table_allocated_entries;
  	hashtable* the_word_memory_hashtable;
  
***************
*** 131,136 ****
--- 171,180 ----
  char *read_headline_table_entry _AP((long position,database* db));
  long write_headline_table_entry _AP((char* headline, database* db));
  
+ #ifdef BIO
+ char *read_delimiters _AP((database* db));
+ long write_delimiters _AP((char* delimiters, database* db));
+ #endif
  
  boolean read_document_table_entry 
    _AP((document_table_entry* doc_entry,long number,database* db));
***************
*** 150,155 ****
--- 194,202 ----
  long add_word_to_dictionary
  	 _AP((char *word, long index_file_block_number, long number_of_occurances,
  	 database* db));
+ #ifdef PARTIALWORD
+ long look_up_partialword_in_dictionary _AP((char *word, long *word_id, database* db));
+ #endif
  long look_up_word_in_dictionary _AP((char *word, long *word_id, database* db));
  long init_dict_file_for_writing _AP((database *db));
  void init_dict_file_detailed _AP((FILE* dictionary_stream,
***************
*** 216,221 ****
--- 263,271 ----
  char* index_filename_with_version _AP((long version, char* destination, 
  				  database* db));
  char* source_filename _AP((char* destination, database* db));
+ #ifdef BIO
+ char* delimiters_filename _AP((char* destination, database* db));
+ #endif
  
  #ifdef __cplusplus
  	}
diff -bwcr wais-8-b5/ir/irhash.h w8b5bio/ir/irhash.h
*** wais-8-b5/ir/irhash.h	Mon Feb 24 22:40:22 1992
--- w8b5bio/ir/irhash.h	Sat Oct 24 12:36:27 1992
***************
*** 32,38 ****
--- 32,42 ----
   * inverted file because the max length of an index block is governed
   * by a size that can be represented in INDEX_BLOCK_SIZE_SIZE bytes.
   */
+ #ifdef BIO
+ #define MAX_OCCURANCES 100000L /* need 100000L, was 20000L, dgg */
+ #else
  #define MAX_OCCURANCES 20000L  
+ #endif
  
  /* this is a flag to be put in the number_of_occurances field of a
  word_entry so that it is always greater than the limit and no words will be
diff -bwcr wais-8-b5/ir/irsearch.c w8b5bio/ir/irsearch.c
*** wais-8-b5/ir/irsearch.c	Sun May 10 16:44:33 1992
--- w8b5bio/ir/irsearch.c	Sun Nov  8 19:17:21 1992
***************
*** 166,171 ****
--- 166,173 ----
      }
  }
  
+ 
+ 
  static long search_word_before_pairs _AP((char *word, long char_pos,
  				       long line_pos, long weight,
  				       long doc_id, time_t date,
***************
*** 226,235 ****
    int * datum;
    count_trie_words = count_uniq = 0;
    /* printf("words: %s\n", words); */
! /*
!   word = strtokf(words,wordDelimiter);
! */
    word = (char*)strtokf_isalnum(words);
    while(word != NULL){
      long dictionary_value;
      /* trim the string if necessary */
--- 228,238 ----
    int * datum;
    count_trie_words = count_uniq = 0;
    /* printf("words: %s\n", words); */
! #ifdef BIO
!   word = (char*)strtokf(words,wordDelimiter);
! #else
    word = (char*)strtokf_isalnum(words);
+ #endif
    while(word != NULL){
      long dictionary_value;
      /* trim the string if necessary */
***************
*** 251,257 ****
--- 254,264 ----
        if (*datum == 1 ) {
        count_uniq++;
        }
+ #ifdef BIO
+     word = (char *)strtokf(NULL,wordDelimiter);
+ #else
      word = (char *)strtokf_isalnum(NULL);
+ #endif
      beFriendly();
    } 
  
***************
*** 311,316 ****
--- 318,504 ----
    return result;
  }
  
+ 
+ /* dgg -- pulled this from irtfiles.c:map_over_words */
+ /* returns the number of words added, or -1 if an error occurred */
+ long search_over_words
+   _AP((char* line,long document_id,database* db));
+        
+ long search_over_words(line, document_id, db) 
+ char* line;
+ long document_id;
+ database* db;
+ {
+   long weight = 1L;
+   long file_position_before_line = 0;
+   boolean word_position= false;
+   boolean word_pairs= false;
+ #ifdef BIO
+   int minwordlen= 1; /* only if symbols are active ? */
+ #else
+   int minwordlen= 2;
+ #endif
+ 
+   long position_in_word = 0;
+   long word_count = 0;
+   unsigned long ch;
+   long char_count = 0;
+   boolean capitalized = false; /* if the word starts with a cap */
+ #ifdef LITERAL
+   char  word[MAX_PHRASE_LENGTH + 1];
+   char  key;
+ #else
+   char word[MAX_WORD_LENGTH + 1];
+ #endif  
+ #ifdef BOOLEANS
+ #define MAX_LINE_LENGTH 1000  
+   boolean  nextIsNot = false;
+   char  notwords[MAX_LINE_LENGTH+1];
+ #endif
+ 
+ 
+ #ifdef BOOLEANS
+   notwords[0]= '\0';
+ #endif
+ 
+   for(ch = (unsigned char)line[char_count++]; 
+       ch != '\0'; ch = (unsigned char)line[char_count++]){
+ #ifdef BIO
+     boolean alnum = (wordDelimiter(ch) == NOT_DELIMITER);
+ #else
+     boolean alnum = isalnum(ch);
+ #endif
+ #ifdef PARTIALWORD
+     if (ch == PARTWORD_WILDCARD) { alnum= true; minwordlen= MAX(2,minwordlen); }
+ #endif
+ #ifdef LITERAL
+    if (ch == LITERAL_KEY1)  key= LITERAL_KEY1;
+    else if (ch == LITERAL_KEY2)  key= LITERAL_KEY2;
+    else key= 0;
+    if (key != 0) {
+       char *cp, *match;
+       cp = line + char_count;  
+       match = strchr( cp, key); 
+ /* printf("search_over_words: literal key is [%c]\n", key); */
+       if (match != NULL && cp < match) {
+ 	  for (position_in_word=0; cp < match; cp++, char_count++)
+             if (position_in_word < MAX_PHRASE_LENGTH) {
+ 	     word[position_in_word++] = char_downcase((unsigned long)*cp);
+ 	     }
+           char_count++; /* skip closing key */
+ 	  alnum= false;
+ 	  capitalized= false;
+ 	  weight= LITERAL_FLAG;   /* is this a safe flag parameter? -- 
+ 	  	unused but passed on to search_word is what we need */
+ 	/* !! need to break literal "word" into 1st dictionary word and search
+ 		on that... */
+ /* printf("search_over_words: literal is [%s]\n", word); */
+ 	  }
+       }
+ #endif
+ 
+     if(alnum){
+       /* put the character in the word if not too long */
+       if(position_in_word == 0)
+ 	capitalized = isupper((unsigned long)ch)?true:false;
+       if(position_in_word < MAX_WORD_LENGTH){
+ 	word[position_in_word++] = char_downcase((unsigned long)ch);
+       }
+     }
+     else{ /* not an in a word */
+       if(position_in_word != 0){
+ #ifdef BOOLEANS
+ /* note on BOOLEANS -- we really need to check for NOT words here,
+    and move them to back of line so that (wordfunction)== search_word is
+    called for NOT words after other words (excluding NOT inside a literal)
+ */
+ 	if (nextIsNot) {
+ 	  word[position_in_word] = '\0';
+ 	  strcat( notwords, word);
+ 	  strcat( notwords, " ");
+ 	  nextIsNot= false;
+  	  word_count++;
+ 	  }
+ 	else if ((strncmp(word,BOOLEAN_NOT,position_in_word)==0)) {
+ 	  nextIsNot= true;
+  	  word_count++;
+ 	  }
+ 	else
+ #endif
+ 	/* then we have collected a word */
+ 	if(position_in_word >= minwordlen){ /* is it reasonable ? */
+ 	  word[position_in_word] = '\0';
+ 	  if(0 != search_word_before_pairs(word,
+ 			     file_position_before_line + char_count,  
+ 			     /*^^  this param is supposed to be start-of-word, but char_count is now at end-of-word !*/
+ 			     0L, /* line_pos */
+ 			     weight, 
+ 			     document_id, 
+ 			     (time_t)0L,
+ 			     capitalized,
+ 			     db))  
+ 	    return(-1); /* error */
+ #ifdef BOOLEANS
+ 	  nextIsNot= false;
+ #endif
+  	  word_count++;
+ 	}
+ 	position_in_word = 0;
+       }
+     }
+   }
+   
+   /* finish last word */
+ #ifdef BOOLEANS
+   if (nextIsNot) {
+     word[position_in_word] = '\0';
+     strcat( notwords, word);
+     strcat( notwords, " ");
+     nextIsNot= false;
+     word_count++;
+     }
+  else 
+ #endif
+  if(position_in_word >= minwordlen){ /* is it reasonable ? */
+     word[position_in_word] = '\0';
+     if(0 != search_word_before_pairs(word,
+ 			    file_position_before_line + char_count, 
+ 			    0L,	/* line_pos */
+ 			    weight, 
+ 			    document_id, 
+ 			    (time_t)0L,
+ 			    capitalized,
+ 			    db))  
+       return(-1);
+     word_count++;
+   }
+   
+ #ifdef BOOLEANS
+   if ((notwords[0] != '\0')) { 
+     char  *wordp;
+     capitalized= false;
+     char_count= 0;       /* !?? need char index for each word ? */
+     weight= BOOLEAN_NOT_FLAG; /* is this a safe parameter ? */   
+     wordp= strtok( notwords, " ");
+     while (wordp!=NULL) {
+       if(0 != search_word_before_pairs(wordp,
+ 			    file_position_before_line + char_count, 
+ 			    0L,	/* line_pos */
+ 			    weight, 
+ 			    document_id, 
+ 			    (time_t)0L,
+ 			    capitalized,
+ 			    db))  
+         return(-1);
+       wordp= strtok(NULL,NULL);
+       }
+     }
+ #endif
+ 
+   return(word_count);
+ }
+ 
+ 
  boolean search_for_words(words, db, doc_id)
       char* words;
       /* break the string into words (using map_over_words)
***************
*** 318,324 ****
  	Returns true if successful.
  	*/
       database *db;
!      long doc_id;
  {
  
  #ifdef BOOL
--- 506,512 ----
  	Returns true if successful.
  	*/
       database *db;
!      long doc_id;  /* = 1 for words == document in relevance feedback search */
  {
  
  #ifdef BOOL
***************
*** 338,351 ****
    }
  #endif  /* def BOOL */
  
    /* NORMAL QUERY */
!   if( -1 == map_over_words(words, doc_id, 1L, 0L, NULL, NULL, db, 
! 			   (wordfunc*)search_word_before_pairs, 0L, 0L))
      return(false);
    else
      return(true);
  }
  
  /* gets the next best hit from the search engine and fills in all the slots.
     If the document does not exist, then it gets another, etc.
     It returns 0 if successful */   
--- 526,544 ----
    }
  #endif  /* def BOOL */
  
+ /* dgg mods really need new version of map_over_words for searching only
+   (not for adding == indexing), and this way we can keep main search
+   routines here (irsearch.c) & search_word in sersrch.c
+ */
+ 
    /* NORMAL QUERY */
!   if( -1 == search_over_words(words, doc_id, db))
      return(false);
    else
      return(true); 
  }
  
+ 
  /* gets the next best hit from the search engine and fills in all the slots.
     If the document does not exist, then it gets another, etc.
     It returns 0 if successful */   
***************
*** 750,755 ****
--- 943,962 ----
      (*diags)[1] = NULL;
      return(false);
    }
+ 
+ #ifdef BIO		/* dgg */
+   {
+     char *cp= read_delimiters( db);  /* use data-specific delimiters, if available */
+     if (cp != NULL) { 
+       strcpy( gDelimiters, cp); 
+       wordDelimiter= wordbreak_user; 
+       }
+     else 
+       wordDelimiter= wordbreak_notalnum;
+   }
+ #else
+   wordDelimiter= wordbreak_notalnum;  /* actually, wordDelimeter is used only ifdef BIO ? */
+ #endif
  
    /* figure out if it is a NEXT or PREVIOUS, if so, return it. */
    header = handle_next_and_previous(wais_search->Docs, db, 
Only in w8b5bio/ir: irsearch.c.O
diff -bwcr wais-8-b5/ir/irsearch.h w8b5bio/ir/irsearch.h
*** wais-8-b5/ir/irsearch.h	Wed Feb  5 16:37:45 1992
--- w8b5bio/ir/irsearch.h	Tue Oct 13 08:32:15 1992
***************
*** 46,51 ****
--- 46,54 ----
  typedef struct search {
  	database*		db;	
  	double*			document_score_array;
+ #ifdef BOOLEANS
+ 	double*		prior_score_array;	/* dgg, 12/91 GS TLG */
+ #endif
  	unsigned long		num_best_hits;
  	hit*			best_hits;
  } search;
Only in w8b5bio/ir: irsearch.h.O
